unit U_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, jpeg, ExtCtrls,U_p4unit, StdCtrls,U_const, Menus, U_P4player,
  ImgList;

type
  TFrm_p4 = class(TForm)
    Img_red: TImage;
    Img_yellow: TImage;
    Img_redwin: TImage;
    Img_yellowwin: TImage;
    Mnu_main: TMainMenu;
    Mnu_jeux: TMenuItem;
    Mnu_new: TMenuItem;
    Mnu_players: TMenuItem;
    Mnu_score: TMenuItem;
    Mnu_exit: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    Curr_pion: TImage;
    Lb_redname: TLabel;
    Lb_yelname: TLabel;
    Lb_redpion: TLabel;
    Lb_yelpion: TLabel;
    Mnu_help: TMenuItem;
    Mnu_about: TMenuItem;
    Img_board: TImage;
    procedure FormCreate(Sender: TObject);
    procedure NewGameClick(Sender: TObject);
    procedure Equality(Sender : TObject);
    procedure Win(Sender : TObject; Var AWinner : TP4Player);
    procedure InfosChange(Sender : TObject; Var CurrentPlayer, RedPlayer,YellowPlayer : TP4Player);
    procedure Mnu_playersClick(Sender: TObject);
    procedure Mnu_scoreClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Mnu_exitClick(Sender: TObject);
    procedure Mnu_aboutClick(Sender: TObject);
  private
    { Dclarations prives }
    FP4Game  : TPuiss4;
  public
    { Dclarations publiques }
  end;

var
  Frm_p4: TFrm_p4;

implementation

uses U_about;


{$R *.dfm}

procedure TFrm_p4.Equality(Sender: TObject);
begin
  MessageDlg('Egalit' + slinebreak + 'plus de pion disponible.', mtInformation, [mbOK], 0);
end;

procedure TFrm_p4.FormCreate(Sender: TObject);
begin
  Doublebuffered        := True;
  FP4Game               := TPuiss4.create;
  With FP4Game do
  begin
    BoardForm     := Frm_p4;
    Board         := Img_board;
    PionSize      := 50;
    PionSpace     := 10;
    RedPion       := Img_red;
    RedPionWin    := Img_redwin;
    YellowPion    := Img_yellow;
    YellowPionWin := Img_yellowwin;
    PlayerOrder   := poRed;
    OnEquality    := Equality;
    OnWin         := Win;
    OnInfosChange := InfosChange;
  end;
end;

procedure TFrm_p4.InfosChange(Sender: TObject; var CurrentPlayer,
  RedPlayer, YellowPlayer: TP4Player);
begin
  Case CurrentPlayer.PionType of
    ppRouge : Curr_pion.Picture.Assign(Fp4Game.RedPion.Picture);
    ppJaune : Curr_pion.Picture.Assign(Fp4Game.YellowPion.Picture);
  end;
  Lb_redName.Visible  := True;
  Lb_yelname.Visible  := True;
  Lb_redpion.Visible  := True;
  Lb_yelpion.Visible  := True;
  Lb_redname.Caption  := RedPlayer.GamerName;
  Lb_yelname.Caption  := YellowPlayer.GamerName;
  Lb_redpion.Caption  := 'Pions restant : ' + inttostr(RedPlayer.PionNumber);
  Lb_yelpion.Caption  := 'Pions restant : ' + intToStr(YellowPlayer.PionNumber);
end;

procedure TFrm_p4.NewGameClick(Sender: TObject);
begin
  If (FP4Game.GameStarted) then
  begin
    if (MessageDlg('Une partie est en cours.'+ slineBreak +'Ets vous sur de vouloir arreter cette partie et de commencer une autre ', mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
    begin
      FP4Game.InitBoard;
      FP4Game.StartGame;
    end;
  end
  else
  begin
    FP4Game.InitBoard;
    FP4Game.StartGame;
  end;
end;

procedure TFrm_p4.Win(Sender: TObject; var AWinner: TP4Player);
begin
  If (MessageDlg(AWinner.GamerName + ' a gagn'+ slinebreak + 'Commencer une autre partie ?', mtInformation, [mbYes, mbNo], 0) = mrYes) then
  begin
    FP4Game.InitBoard;
    FP4Game.StartGame;
  end
end;

procedure TFrm_p4.Mnu_playersClick(Sender: TObject);
begin
  FP4Game.InitPlayers;
end;

procedure TFrm_p4.Mnu_scoreClick(Sender: TObject);
begin
  FP4Game.ShowScores;
end;

procedure TFrm_p4.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  If (FP4Game.GameStarted) then
  begin
    if (MessageDlg('Une partie est en cours.'+ slineBreak +'Ets vous sur de vouloir quitter le jeux ?''', mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
      CanClose := True
    else
      CanClose  := False;
  end
  else
    CanClose := true;
end;

procedure TFrm_p4.Mnu_exitClick(Sender: TObject);
begin
  Close;
end;

procedure TFrm_p4.Mnu_aboutClick(Sender: TObject);
begin
  With TFrm_about.Create(Nil) do
  try
    ShowModal;
  finally
    Release;
  end;
end;

end.
