unit U_p4player;

interface
Uses U_const;

type

TP4Player = class;
TP4Players = Array[0..1] of TP4Player;

TP4Player = class
  private
    FGameWon: Integer;
    FGameLost: Integer;
    FGameNumber: Integer;
    FPionNumber: Integer;
    FGamerName: String;
    FPionType: TP4Pion;
    procedure SetGameLost(const Value: Integer);
    procedure SetGameNumber(const Value: Integer);
    procedure SetGamerName(const Value: String);
    procedure SetGameWon(const Value: Integer);
    procedure SetPionNumber(const Value: Integer);
    procedure SetPionType(const Value: TP4Pion);
  public
    constructor Create;
    procedure   UpdateScores(ALost,AWon,ANumber : Integer);
  published
    property GamerName  : String read FGamerName write SetGamerName;
    property GameWon    : Integer read FGameWon write SetGameWon;
    property GameLost   : Integer read FGameLost write SetGameLost;
    property GameNumber : Integer read FGameNumber write SetGameNumber;
    property PionNumber : Integer read FPionNumber write SetPionNumber;
    property PionType   : TP4Pion read FPionType write SetPionType;
end;

implementation

{ TP4Player }

constructor TP4Player.Create;
begin
  Inherited Create;
  FPionNumber := 21;
end;

procedure TP4Player.SetGameLost(const Value: Integer);
begin
  FGameLost := Value;
end;

procedure TP4Player.SetGameNumber(const Value: Integer);
begin
  FGameNumber := Value;
end;

procedure TP4Player.SetGamerName(const Value: String);
begin
  FGamerName := Value;
end;

procedure TP4Player.SetGameWon(const Value: Integer);
begin
  FGameWon := Value;
end;

procedure TP4Player.SetPionNumber(const Value: Integer);
begin
  FPionNumber := Value;
end;

procedure TP4Player.SetPionType(const Value: TP4Pion);
begin
  FPionType := Value;
end;

procedure TP4Player.UpdateScores(ALost,AWon,ANumber : Integer);
begin
  FGameWon  := AWon;
  FGameLost := ALost;
  FGameNumber := ANumber;
end;

end.
