{
 CLASSE DE GESTION DU JEUX PUISSANCE 4
 AUTEUR : ANDRY
}

unit U_p4unit;

interface

uses
  Classes, Graphics,ExtCtrls, Forms, SysUtils, U_const, U_p4player;
Type

  TWinnerProc   = procedure (Sender : TObject; Var AWinner : TP4Player) of Object;
  TInfosProc    = procedure (Sender : TObject; Var CurrentPlayer, RedPlayer,YellowPlayer : TP4Player) of Object;

  TPuiss4 = Class
  private
    FBoardForm        : TForm;
    FBoard            : TImage;       //Image de la planche
    FRedPion          : TImage;       //Image du pion rouge
    FRedPionWin       : TImage;       //Image du pion rouge gagnant
    FYellowPion       : TImage;       //Image du pion jaune
    FYellowPionWin    : TImage;       //Image du pion jaune gagnant
    FBallIsAnimated   : Boolean;      //permet de savoir si un pion est en cours de descente
    FP4Board          : TP4Board;     //Tableau d'image de pion
    FP4Tablo          : TP4Tablo;     //Tableau de pion
    FP4Result         : TP4Result;    //Tableau indiquant les emplacement des pion gagant
    FP4Players        : TP4Players;   //Tableau de joueur
    FOnEquality       : TNotifyEvent; //Evenement sur egalit
    FOnWin            : TWinnerProc;  //Evenement sur vitcoire
    FPionSize         : Integer;      //Taille d'un pion
    FGameStarted      : Boolean;
    FPlayerNum        : Integer;
    FOnInfosChange    : TInfosProc;   //Evenement sur changement d'infos durant le jeu
    FPlayerOrder      : TP4Order;     //Ordre de joueur
    FCurrentPlayer    : TP4Player;    //Joueur en cours
    FPionSpace        : Integer;      //Espace entre les pions
    FBoardCreated     : Boolean;

    procedure SetCurrentPlayer(const Value: TP4Player);
    procedure SetPionSize(const Value: Integer);
    procedure SetBoard(Value : TImage);
    procedure SetRedPion (Value : TImage);
    procedure SetRedPionWin(Value : TImage);
    procedure SetYellowPion(Value : TImage);
    procedure SetYellowPionwin(Value : TImage);
    procedure SetPlayerOrder(const Value: TP4Order);
    procedure SetPionSpace(const Value: Integer);
    procedure SetGameStarted(const Value: Boolean);
    function  FirstRowEmpty(Column : Integer) : Integer;
    function  NewPion(Column : Integer; Pion : TP4pion) : Boolean;
    function  IsWinner(Pion: TP4Pion): Boolean;
  protected
    procedure   DoWin;
    procedure   DoEquality;
    procedure   DoInfosChange;
    procedure   CreateBoard;
    procedure   CreatePlayers;
    procedure   PionClick(Sender: TObject);
    procedure   CursorMouseMove(Sender: TObject; Shift: TShiftState;  X, Y: Integer);
  public
    constructor create;
    destructor  destroy;override;
    procedure   StartGame;
    procedure   InitBoard;
    procedure   ShowScores;
    procedure   InitPlayers;
  published
    property    BoardForm      : TForm read FBoardForm write FBoardForm;
    property    PionSize       : Integer read FPionSize write SetPionSize;
    property    OnWin          : TWinnerProc read FOnWin write FOnWin;
    property    OnEquality     : TNotifyEvent read FOnEquality write FOnEquality;
    property    CurrentPlayer  : TP4Player read FCurrentPlayer write SetCurrentPlayer;
    property    OnInfosChange  : TInfosProc read FOnInfosChange write FOnInfosChange;
    property    GameStarted    : Boolean read FGameStarted write SetGameStarted;
    property    Board          : TImage read FBoard write SetBoard;
    property    RedPion        : TImage read FRedPion write SetRedPion;
    property    RedPionWin     : TImage read FRedPionWin write SetRedPionWin;
    property    YellowPion     : TImage read FYellowPion write SetYellowPion;
    property    YellowPionWin  : Timage read FYellowPionWin write SetYellowPionwin;
    property    PlayerOrder    : TP4Order read FPlayerOrder write SetPlayerOrder;
    property    PionSpace      : Integer read FPionSpace write SetPionSpace;
  end;

implementation

uses Types, Controls, Dialogs, U_Pion, U_players, U_score;

{===============================================================================
                               PRIVATE SECTION
===============================================================================}
procedure TPuiss4.SetBoard(Value: TImage);
begin
  FBoard.Picture.Assign(Value.Picture);
  FBoard.Top  := Value.Top;
  FBoard.Left := Value.Left;
  FBoard.Width  := Value.Width;
  FBoard.Height := Value.Height;
  Value.OnMouseMove   := CursorMouseMove;
end;
{------------------------------------------------------------------------------}
procedure TPuiss4.SetCurrentPlayer(const Value: TP4Player);
begin
  FCurrentPlayer := Value;
end;
{------------------------------------------------------------------------------}
procedure TPuiss4.SetGameStarted(const Value: Boolean);
begin
  FGameStarted := Value;
end;
{------------------------------------------------------------------------------}
procedure TPuiss4.SetPionSize(const Value: Integer);
begin
  FPionSize := Value;
end;
{------------------------------------------------------------------------------}
procedure TPuiss4.SetPionSpace(const Value: Integer);
begin
  FPionSpace := Value;
end;
{------------------------------------------------------------------------------}
procedure TPuiss4.SetPlayerOrder(const Value: TP4Order);
begin
  FPlayerOrder := Value;
  case  FPlayerOrder of
    poRed     : FPlayerNum := 0;
    poYellow  : FPlayerNum  := 1;
    poRandom  : FPlayerNum  := Random(99) div 50;
  end;
  FCurrentPlayer := FP4Players[FPlayerNum];
end;
{------------------------------------------------------------------------------}
procedure TPuiss4.SetRedPion(Value: TImage);
begin
  FRedPion.Picture.Assign(Value.Picture);
end;
{------------------------------------------------------------------------------}
procedure TPuiss4.SetRedPionWin(Value: TImage);
begin
  FRedPionWin.Picture.Assign(Value.Picture);
end;
{------------------------------------------------------------------------------}
procedure TPuiss4.SetYellowPion(Value: TImage);
begin
  FYellowPion.Picture.Assign(Value.Picture);
end;
{------------------------------------------------------------------------------}
procedure TPuiss4.SetYellowPionwin(Value: TImage);
begin
  FYellowPionWin.Picture.Assign(Value.Picture);
end;
{------------------------------------------------------------------------------}
function TPuiss4.FirstRowEmpty(Column: Integer): Integer;
  Var ln : Integer;
begin
  For ln := 0 to ctMaxRow do
  begin
    If FP4Tablo[Column,ln] <> ppVide then
      break;
  end;
  Result :=  ln - 1;
end;
{------------------------------------------------------------------------------}
function TPuiss4.NewPion(Column: Integer; Pion: TP4pion): Boolean;
Var  lRow,i   : Integer;  //Ligne courante
     PictBall : tPicture; //Notre Pion
begin
  Result := True;
  // trouvons la premire ligne vide
  lRow := FirstRowEmpty(Column);
  if (lRow = -1) then
  begin
    Result := False;
    Exit;
  end;
  // Mettons notre flag  true pendant le processus d'affichage du pion pour
  // eviter les clics successifs
  i := 0;
  FBallIsAnimated := True;
  PictBall  := TPicture.Create;
  try
    case Pion of
      ppJaune  : PictBall.Assign(FYellowPion.Picture);
      ppRouge  : PictBall.Assign(FRedPion.Picture);
    end;
    while (i <= lRow) do
    begin
      FP4Board[Column,i].Picture  := PictBall;
      Application.ProcessMessages;
      sleep(ctScrSpeed);
      FP4Board[Column,i].Picture  := Nil;
      Application.ProcessMessages;
      inc(i);
    end;
    FP4Board[Column,lRow].Picture  := PictBall;
    FP4Tablo[Column,lRow] := Pion;
  finally
    PictBall.Free;
    FBallIsAnimated := False;
    // Le pion est sur sa cellule, desactivons le flag pour permettre un
    // nouvel affichage
  end;
end;
{------------------------------------------------------------------------------}
function TPuiss4.IsWinner(Pion: TP4Pion): Boolean;
var
 lRow,lCol,lPas : Integer;
begin
   Result := False;
  // Parcours en vertical
  For lCol:=0 to ctMaxCol do
  begin
    For lPas:=0 to 2 do
    begin
      If (not Result) and
         (FP4Tablo[lCol,0+lPas] = Pion)and
         (FP4Tablo[lCol,1+lPas] = Pion)and
         (FP4Tablo[lCol,2+lPas] = Pion)and
         (FP4Tablo[lCol,3+lPas] = Pion)then
        begin
          Result  :=True;
          FP4Result[0].Col  := lCol;
          FP4Result[0].Row  := lPas;
          FP4Result[1].Col  := lCol;
          FP4Result[1].Row  := 1+lPas;
          FP4Result[2].Col  := lCol;
          FP4Result[2].Row  := 2+lPas;
          FP4Result[3].Col  := lCol;
          FP4Result[3].Row  := 3+lPas;
        end;
    end;
  end;
  // On parcours horizontal
  If not Result then
  begin
    For lRow := 0 to ctMaxRow do
    begin
      For lPas := 0 to 3 do
        If (not Result)and
           (FP4Tablo[0+lPas,lRow]=Pion)and
           (FP4Tablo[1+lPas,lRow]=Pion)and
           (FP4Tablo[2+lPas,lRow]=Pion)and
           (FP4Tablo[3+lPas,lRow]=Pion)then
          begin
            Result := True;
            FP4Result[0].Col  := lPas;
            FP4Result[0].Row  := lRow;
            FP4Result[1].Col  := 1+lPas;
            FP4Result[1].Row  := lRow;
            FP4Result[2].Col  := 2+lPas;
            FP4Result[2].Row  := lRow;
            FP4Result[3].Col  := 3+lPas;
            FP4Result[3].Row  := lRow;
          end;
      end;
    end;
  // Parcours Diagonale Gauche
  If not Result then
  begin
    For lCol:=0 to 3 do
    begin
      For lRow:=0 Downto -2 do
      begin
        If (not Result)     and
           (FP4Tablo[0+lCol,2+lRow]=Pion)and
           (FP4Tablo[1+lCol,3+lRow]=Pion)and
           (FP4Tablo[2+lCol,4+lRow]=Pion)and
           (FP4Tablo[3+lCol,5+lRow]=Pion)then
        begin
          Result:=True;
          FP4Result[0].Col  := lCol;
          FP4Result[0].Row  := 2+lRow;
          FP4Result[1].Col  := 1+lCol;
          FP4Result[1].Row  := 3+lRow;
          FP4Result[2].Col  := 2+lCol;
          FP4Result[2].Row  := 4+lRow;
          FP4Result[3].Col  := 3+lCol;
          FP4Result[3].Row  := 5+lRow;
        end;
      end;
    end;
  end;

  // Parcours Diagonale Droite
  If not Result then
  begin
    For lCol:=0 to 3 do
    begin
      For lRow:=0 Downto -2 do
      begin
        If (not Result)     and
           (FP4Tablo[0+lCol,5+lRow]=Pion)and
           (FP4Tablo[1+lCol,4+lRow]=Pion)and
           (FP4Tablo[2+lCol,3+lRow]=Pion)and
           (FP4Tablo[3+lCol,2+lRow]=Pion)then
        begin
          Result:=True;
          FP4Result[0].Col  := lCol;
          FP4Result[0].Row  := 5+lRow;
          FP4Result[1].Col  := 1+lCol;
          FP4Result[1].Row  := 4+lRow;
          FP4Result[2].Col  := 2+lCol;
          FP4Result[2].Row  := 3+lRow;
          FP4Result[3].Col  := 3+lCol;
          FP4Result[3].Row  := 2+lRow;
        end;
      end;
    end;
  end;
end;
{===============================================================================
                               PROTECTED SECTION
===============================================================================}
procedure TPuiss4.DoWin;
Var i : Integer;
begin
  For i:= 0 to 3 do
  begin
    Case FCurrentPlayer.PionType of
      ppJaune : FP4Board[FP4Result[i].Col,FP4Result[i].Row].Picture := FYellowPionWin.Picture;
      ppRouge : FP4Board[FP4Result[i].Col,FP4Result[i].Row].Picture := FRedPionWin.Picture;
    end;
  end;
  With FP4Players[FPlayerNum] do
  begin
    GameNumber  := GameNumber +1;
    GameWon     := GameWon +1;
  end;
  with FP4Players[(FPlayerNum + 1) mod 2] do
  begin
    GameNumber  := GameNumber +1;
    GameLost    := GameLost +1;
  end;
  FGameStarted  := False;
  if Assigned(FOnWin) then
    FOnWin(Self,FCurrentPlayer);
end;
{------------------------------------------------------------------------------}
procedure TPuiss4.DoEquality;
begin
  With FP4Players[0] do
    GameNumber := GameNumber +1;
  with FP4Players[1] do
    GameNumber := GameNumber +1;
  FGameStarted  := False;    
  if assigned(FOnEquality) then
    FOnEquality(Self);
end;
{------------------------------------------------------------------------------}
procedure TPuiss4.DoInfosChange;
begin
  if Assigned(FOnInfosChange) then
    FOnInfosChange(Self,FCurrentPlayer,FP4Players[0],FP4Players[1]);
end;
{------------------------------------------------------------------------------}
procedure TPuiss4.CreateBoard;
var
  ln,cl : integer;
  PionImage : TPionImage;
begin
  For ln := 0 to ctMaxRow do
  begin
    for cl := 0 to ctMaxCol do
    begin
      FP4Tablo[cl,ln]  := ppVide;
      PionImage := TPionImage.Create(Nil);
      With PionImage do
      begin
        Parent  := FBoardForm;
        Top     := FBoard.Top + 10 + ln * (FPionSize + FPionSpace);
        Left    := FBoard.left + 10 + cl * (FPionSize + FPionSpace);
        Width   := FPionSize ;
        Height  := FPionSize;
        Name    := 'Case'+IntToStr(ln)+IntToStr(cl);
        Column  := cl;
        Row     := ln;
      end;
      FP4Board[cl,ln] := PionImage;
      FP4Board[cl,ln].OnClick := PionClick;
      FP4Board[cl,ln].OnMouseMove := CursorMouseMove;
    end;
  end;
  FBoardCreated := True;
end;
{------------------------------------------------------------------------------}
procedure TPuiss4.CreatePlayers;
Var i : Integer;
    Player  : Tp4Player;
begin
  For i := 0 to 1 do
  begin
    Player  := TP4Player.Create;
    FP4Players[i] :=  Player;
  end;
  FP4Players[0].GamerName := 'JOUEUR ROUGE';
  FP4Players[0].PionType  := ppRouge;
  FP4Players[1].GamerName := 'JOUEUR JAUNE';
  FP4Players[1].PionType  := ppJaune;
end;
{===============================================================================
                               PUBLIC SECTION
===============================================================================}
constructor TPuiss4.create;
begin
  inherited Create;
  CreatePlayers;
  FBoard              := TImage.Create(Nil);
  FRedPion            := TImage.Create(Nil);
  FRedPionWin         := TImage.Create(Nil);
  FYellowPion         := TImage.Create(Nil);
  FYellowPionWin      := TImage.Create(Nil);
  FBoardCreated       := False;
//  FBoard.OnMouseMove  := CursorMouseMove;
  Randomize;
end;
{------------------------------------------------------------------------------}
destructor TPuiss4.destroy;
Var ln,cl : Integer;
begin
  For ln := 0 to ctMaxRow do
  begin
    for cl := 0 to ctMaxCol do
    begin
      FP4Board[cl,ln].Free;
    end;
  end;
  For ln := 0 to 1 do
    FP4Players[ln].Free;
  FBoard.Free;
  FRedPion.Free;
  FRedPionWin.Free;
  FYellowPion.Free;
  FYellowPionWin.Free;
  Inherited;
end;
{------------------------------------------------------------------------------}
procedure TPuiss4.PionClick(Sender: TObject);
begin
  if ((GameStarted) and  (FCurrentPlayer.PionNumber > 0) and (Not FBallIsAnimated)) then
  begin
    If NewPion((Sender as TPionImage).Column,FCurrentPlayer.PionType) then
    begin
      if IsWinner(FCurrentPlayer.PionType) then
      begin
        GameStarted := False;
        DoWin;
      end
      else
      begin
        With FCurrentPlayer do
          PionNumber  := PionNumber -1;
        FPlayerNum := (FPlayerNum +1) mod 2;
        FCurrentPlayer := FP4Players[FPlayerNum];
        DoInfosChange;
        if ((FP4Players[0].PionNumber = 0) and (FP4Players[1].PionNumber = 0)) then
        begin
          GameStarted := False;
          DoEquality;
          Exit;
        end;
      end;
    end;
  end
end;
{------------------------------------------------------------------------------}
procedure TPuiss4.CursorMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
begin
  if ((FGameStarted)  and (Sender is TPionImage))then
    Screen.Cursor  := crHandPoint
  else
    Screen.Cursor  := crArrow;
end;
{------------------------------------------------------------------------------}
procedure TPuiss4.InitBoard;
var
  ln,cl : integer;
begin
  If Not FBoardCreated then
    CreateBoard
  else
  begin
    For ln := 0 to ctMaxRow do
    begin
      for cl := 0 to ctMaxCol do
      begin
        FP4Tablo[cl,ln]  := ppVide;
        FP4Board[cl,ln].Picture := nil;
      end;
    end;
  end;
end;
{------------------------------------------------------------------------------}
procedure TPuiss4.StartGame;
begin
  GameStarted               := True;
  FP4Players[0].PionNumber  := 21;
  FP4Players[0].PionType    := ppRouge;
  FP4Players[1].PionNumber  := 21;
  FP4Players[1].PionType    := ppJaune;
  CurrentPlayer := FP4Players[FPlayerNum];
  DoInfosChange
end;
{------------------------------------------------------------------------------}
procedure TPuiss4.InitPlayers;
begin
  With TFrm_players.Create(Nil) do
  try
    RedGamerName    := FP4Players[0].GamerName;
    RedGamerWin     := FP4Players[0].GameWon;
    RedGamerlost    := FP4Players[0].GameLost;
    RedGamerGame    := FP4Players[0].GameNumber;
    YellowGamerName := FP4Players[1].GamerName;
    YellowGamerWin  := FP4Players[1].GameWon;
    YellowGamerLost := FP4Players[1].GameLost;
    YellowGamerGame := FP4Players[1].GameNumber;
    if Execute then
    begin
      FP4Players[0].GamerName   := RedGamerName;
      FP4Players[0].PionType    := ppRouge;
      FP4Players[0].PionNumber  := 21;
      FP4Players[1].GamerName   := YellowGamerName;
      FP4Players[1].PionType    := ppJaune;
      FP4Players[1].PionNumber  := 21;
      PlayerOrder               := TP4Order(Ordre);
    end;
  finally
    Release;
  end;
//  DoInfosChange
end;

procedure TPuiss4.ShowScores;
begin
  With TFrm_score.Create(Nil) do
  try
    RedGamerName    := FP4Players[0].GamerName;
    RedGamerWin     := FP4Players[0].GameWon;
    RedGamerlost    := FP4Players[0].GameLost;
    RedGamerGame    := FP4Players[0].GameNumber;
    YellowGamerName := FP4Players[1].GamerName;
    YellowGamerWin  := FP4Players[1].GameWon;
    YellowGamerLost := FP4Players[1].GameLost;
    YellowGamerGame := FP4Players[1].GameNumber;
    ShowModal;
  finally
    release;
  end;
end;
end.
